
% One-sided autocorrelation function of size/lag p: acf = [rxx(0), rxx(1),...,rxx(p-1)].
% 2011 Even Brenden

function [rxx] = acf(x, p)

	N = length(x);
	rxx = zeros(1, p);	

	for j=1:p
		for n=1:N
			if n+j-1>0 & n+j-1<=N
				rxx(j) += x(n)*x(n+j-1);
			end
		end
	end	
