
% Script for calculating complex AQB constants offline for faster C implementation.

bits=4;

alpha=0.9;			% Memory factor
lt_std_dev=0.11179;		% Long-.term standard deviation
init_delta=2^-(bits-1);		% Initial [-1, 1) step size
nu=init_delta/lt_std_dev;	% Scale factor

AQB_CONST=(1-alpha)*(nu^2);
AQB_CONST_Q16=double2Q16(AQB_CONST);
AQB_CONST_Q16_HEX=dec2hex(double(AQB_CONST_Q16));
disp(strcat("0x", num2str(AQB_CONST_Q16_HEX)));