
% Complex AQB test script.

bits=4;				% Q bits

% Q and de-Q params
alpha=0.9;			% Memory factor
lt_std_dev=0.7;		% This is adjusted for the test script. lydbok_1_10bit_14700Hz.wav gives 0.11179
init_delta=2^-(bits-1);		% Initial [-1, 1) step size
nu=init_delta/lt_std_dev;	% Scale factor

% Input signal.
x=loadaudio("../audio/lydbok/lydbok_1_10bit_14700Hz_cut", "raw", 16)/2^15;
N=length(x);

codewords=zeros(1, N);
dequantized=zeros(1, N);
deltas=zeros(1, N);

% Run complex AQB simulation.
for i=1:N

	if i==1
		delta = aqb_delta_calc(0, init_delta, bits, alpha, nu);
	else
		delta = aqb_delta_calc(dequantized(i-1), deltas(i-1), bits, alpha, nu);
	end
	
	codewords(i) = aqb_encoder(x(i), delta, bits);
	dequantized(i) = aqb_decoder(codewords(i), delta, bits);
	deltas(i)=delta;
	
	% Output results to console.
	%disp(strcat('codeword:', num2str(codewords(i))));
	%disp(strcat('delta:', num2str(deltas(i))));
	%disp(strcat('y:', num2str(dequantized(i))));
	%pause();
end

clf;
plot(x, 'k')
hold on;
plot(dequantized);
plot(deltas, 'r');
% Also plot codewords normalized to [-1, 1]
plot(codewords/2^bits, 'g');

sum_abs_error=sum(abs(x'-dequantized))

wavwrite(dequantized' , 14700, 16, "../sandbox/a_q_test.wav");