
% Convert double f to Q16 (int32).
% 2012 Even Brenden

function [q] = double2Q16(f)

	% Get sign.
	neg=0;
	if (f<0)
		f=-f;
		neg=1;
	end

	% Create string.
	
	bin_str = "0";
	q=int32(0);
	
	for i=31:-1:17
		% Integer part.
		if (f>=2^(i-17))
			bin_str = [bin_str "1"];
			f-=2^(i-17);
			q+=2^(i-1);
		else	
			bin_str = [bin_str "0"];
		end	
	end
	for i=1:16
		% Fractional part.
		if (f>=2^(-i))
			bin_str = [bin_str "1"];
			f-=2^(-i);
			q+=2^(16-i);
		else	
			bin_str = [bin_str "0"];
		end	
	end

	% Do 2's comp if negative.
	if (neg)
		dec_str = bin2dec(bin_str);
		dec_str += 1;
		bin_str = dec2bin(dec_str, 32);
		for i=1:32
			if(bin_str(i) == "1")
				bin_str(i) = "0";
			else
				bin_str(i) = "1";
			end
		end
		q = -q;
	end
	
	% disp(bin_str);

