
% Script for drawing examples of error concealment.
% 2021 Even Brenden

N=256;

welcome = wavread("lydbok_1_44k_16bit")(20000:20000+N*3);
welcome /= max(welcome);

% Zero-padding and filtering.

welcome_zp = [welcome(1:N); zeros(N, 1); welcome(2*N:end)];

fw=0.125;
L=147;
type = 'lp';
window = 'hamming';
b = fir1(L-1, fw, type, window);

welcome_zp_f=filter(b, 1, welcome_zp);
welcome_zp_f=[welcome_zp_f; welcome(end-L:end)];

% Insert WN.

welcome_wn = [welcome(1:N); (rand(N, 1)-0.5)*var(welcome)*5; welcome(2*N:end)];

% Repeat last block.

welcome_rb = [welcome(1:N); welcome(1:N); welcome(2*N:end)];

figure
subplot(3, 1, 1);
plot(welcome_zp_f((L-1)/2:end));
axis([0 3*N -1 1]);
ylabel('Amplitude');
legend('Method 1');
legend('boxon');
subplot(3, 1, 2);
plot(welcome_wn);
axis([0 3*N -1 1]);
ylabel('Amplitude');
legend('Method 2');
legend('boxon');
subplot(3, 1, 3);
plot(welcome_rb);
axis([0 3*N -1 1]);
xlabel('Samples');
ylabel('Amplitude');
legend('Method 3');
legend('boxon');

print("error_concealment.eps");