
% Script for drawing example figure for noise reduction.
% 2012 Even Brenden

N=1024;
n=1:N;
f=16;
sine = sin(2*pi*f*(n./N));
sine(N/4:5*N/8) *= 0.5;

tresh = 0.5;
att = 0.125;
F=16;
history = 0;

sine_nr = zeros(1, N);
for i=1:F:N-F-1
	[sine_nr(i:i+F-1), history] = expander(sine(i:i+F-1), tresh, att, history, F);
end

clf
figure(1)
plot(sine);
hold on;
plot(sine_nr, 'r');
xlabel('Samples');
ylabel('Amplitude');
axis([0 N-24 -1.5 1.5]);
legend("Original", "Noise reduction");

print('tresholding_ex.eps');

figure(2)
n=n/N;
dynamics = n;
att = 0.5;
dynamics(1:tresh*N) *= att;
plot(n, dynamics);
set(gca,'XTick', 0:0.25:1);
set(gca,'XTickLabel',{'0', '0.25' 'Treshold', '0.75', '1'});
set(gca,'YTick', 0:0.25:1);
xlabel('Possible absolute amplitudes of X');
ylabel('Possible absolute amplitudes of Y');

print('dynamics_ex.eps');
