
% Script that generates sines for ADC test.
% 2021 Even Brenden

clear all;
close all;

fs=44100;
M=fs;
N=5*M; 	% Must be larger than pi*2^B=3217 for B=10.

no_sines=8;

F=[99 297 891 1089 2673 3267 5049 6831]; % Relatively prime to M

f=fs*(F/M);

x=zeros(no_sines, N);
x_ft=zeros(no_sines, M);

for i=1:no_sines
	x(i, :)=sin(2*pi*[1:N]*(f(i)/fs));
	x_ft(i, :)=abs(fft(x(i, :), M));
end

x_tot=zeros(1, 2*N*no_sines);
for i=1:no_sines
	x_tot(2*(i-1)*N+1:2*(i-1)*N+N)=x(i, :);
end

amp=0.25; % -12dB
wavwrite(amp*x_tot', fs, 16, 'prime_sines_44k_16bit.wav');