
% LPC analysis by solving linear equations. Returns [a(1) ... a(p)] with acf=[rxx(0) ... rxx(p)].
% 2011 Even Brenden

function [a] = lpc_direct(rxx, p)

	if size(rxx)(1)<size(rxx)(2)
		rxx=rxx';
	end

	% To be solved with Levinson-Durbin recursion i C code
	Rxx = toeplitz(rxx(1:p));
	a = -inv(Rxx)*rxx(2:p+1);

	a=a';
