
% One-word-memory AQB step size calculation.
% 2012 Even Brenden

function [delta] = maqb_delta_calc(prev_delta, prev_codeword, bits)

% Step size multiplier tables.
M4 = [0xEAAA 0xEAAA 0xEAAA 0xEAAA 0x13333 0x19999 0x20000 0x23333];
M3 = [0xE666 0xEAAA 0x13333 0x20000];
M2 = [0xEAAA 0x13333];

for i=1:8
	M4(i)=Q162double(M4(i));
end
for i=1:4
	M3(i)=Q162double(M3(i));
end
for i=1:2
	M2(i)=Q162double(M2(i));
end

% Get codeword in [1, 2^(bits-1)].
if(prev_codeword<0)
	prev_codeword=abs(prev_codeword);
else
	prev_codeword++;
end

% Calc delta.
if (bits==4)
	delta=prev_delta*M4(prev_codeword);
elseif (bits==3)
	delta=prev_delta*M3(prev_codeword);
elseif (bits==2)
	delta=prev_delta*M2(prev_codeword);
end
