
% One-word-memory AQB test script.

bit_range=[2:4];
P=1;
a=[0.9];

for bits=bit_range

	x=loadaudio('../audio/results/NR_NOCOMP', 'raw', 16)/2^15;
	N=length(x);

	init_delta=2^-(bits-1);	% Initial [-1, 1) step size

	codewords=zeros(1, N);
	e=zeros(1, N);
	y=zeros(1, N);
	deltas=zeros(1, N);
	
	x_hat = 0;
	x_tilde = zeros(1, P);
	xt_pointer = 1;
	s_hat = 0;
	s_tilde = zeros(1, P);
	st_pointer = 1;
	
	for i=1:N
	
		% Q encoder
		if i==1 delta = maqb_delta_calc(init_delta, 0, bits);
		else delta = maqb_delta_calc(deltas(i-1), codewords(i-1), bits);
		end
		codewords(i) = maqb_encoder(x(i)-x_hat, delta, bits);
		e(i) = maqb_decoder(codewords(i), delta, bits);
		deltas(i)=delta;
		
		% DPCM encoder
	        x_tilde(xt_pointer)=e(i)+x_hat;
	        x_hat=0;
	        for k=1:P
			index=mod(xt_pointer-k+1, P);
			if index==0 index=P; end
	                x_hat+=a(k)*x_tilde(index);
	        end
		xt_pointer++;
		if xt_pointer==P+1 xt_pointer=1; end
		
		% DPCM decoder
		s_tilde(st_pointer)=e(i)+s_hat;
		y(i)=s_tilde(st_pointer);
		s_hat=0;
		for k=1:P
			index=mod(st_pointer-k+1, P);
			if index==0 index=P; end
			s_hat+=a(k)*s_tilde(index);
		end
		s_ = s_tilde(st_pointer);
	        st_pointer++;
        	if st_pointer==P+1 st_pointer=1; end
		
	end

	mse=MSE(x, y);

	fprintf(fileid, '\nSSM-AQB');
	fprintf(fileid, strcat('\nDBITS: ', num2str(bits)));
	fprintf(fileid, strcat('\nMSE:   ', num2str(mse), '\n'));

	wavwrite(y' , 14000, 16, strcat("../audio/results/double_SSM-AQB_DBITS", num2str(bits), ".wav"));
end

fclose(fileid);