/* Copyright (c) 2011 Nordic Semiconductor. All Rights Reserved.
 *
 * The information contained herein is property of Nordic Semiconductor ASA.
 * Terms and conditions of usage are described in detail in NORDIC
 * SEMICONDUCTOR STANDARD SOFTWARE LICENSE AGREEMENT.
 *
 * Licensees are granted free, non-transferable use of the information. NO
 * WARRANTY of ANY KIND is provided. This heading must NOT be removed from
 * the file.
 *
 * $LastChangedRevision: 7265 $
 */


/**
 * @file
 * @brief Gazell Link Layer constants.
 *
*/

#ifndef NRF_GZLL_CONSTANTS_H__
#define NRF_GZLL_CONSTANTS_H__

/**
* @defgroup gzll_api_constants Gazell Link Layer API
* @{
* @ingroup gzll_api
* @brief Constants for the Gazell Link Layer library.
*/

/** Default channel table */
#define NRF_GZLL_DEFAULT_CHANNEL_TABLE  {10, 20, 30, 40, 50}
#define NRF_GZLL_DEFAULT_CHANNEL_TABLE_SIZE 5         ///< Default channel table size
#define NRF_GZLL_CONST_MAX_CHANNEL_TABLE_SIZE 10UL    ///< Maximum channel table size allowed by Gazell.

#define NRF_GZLL_CONST_MAX_PAYLOAD_LENGTH 32 ///< Maximum allowed payload length in bytes. 

   
#define NRF_GZLL_DEFAULT_FULL_ADDRESS_PIPE0 {0x55, 0x2E, 0xC1, 0xA5, 0xC1}          ///< Default full address, first byte is the address for pipe 0, remaining byte are the base address 0.
#define NRF_GZLL_DEFAULT_BASE_ADDRESS_0_LENGTH NRF_GZLL_BASE_ADDRESS_LENGTH_4B      ///< Default length in bytes of base address 0.

#define NRF_GZLL_DEFAULT_TIMESLOT_PERIOD 2500    ///< Default timeslot period (The Rx period on legacy Gazell should be twice this value)

/** @} */

/** @} */

#endif
