
/****************************************************************************************************//**
 * @file     nRF51.h
 *
 * @status   EXPERIMENTAL
 *
 * @brief    CMSIS Cortex-M0 Core Peripheral Access Layer Header File for
 *           default nRF51 Device Series
 *
 * @version  V1.4
 * @date     22. March 2012
 *
 * @note     Generated with SVDConv V2.6 Build 5c  on Thursday, 22.03.2012 09:22:24
 *
 *           from CMSIS SVD File 'nRF51.xml' Version 1.4,
 *           created on Thursday, 22.03.2012 08:22:15, last modified on Thursday, 22.03.2012 08:22:15
 *
 *******************************************************************************************************/



/** @addtogroup ARM
  * @{
  */

/** @addtogroup nRF51
  * @{
  */

#ifndef __NRF51_H__
#define __NRF51_H__

#ifdef __cplusplus
extern "C" {
#endif 



/********************************************
** Start of section using anonymous unions **
*********************************************/

#if defined(__ARMCC_VERSION)
  #pragma push
  #pragma anon_unions
#elif defined(__CWCC__)
  #pragma push
  #pragma cpp_extensions on
#elif defined(__GNUC__)
  /* anonymous unions are enabled by default */
#elif defined(__IAR_SYSTEMS_ICC__)
  #pragma push
  #pragma language=extended
#else
  #error Not supported compiler type
#endif


 /* Interrupt Number Definition */

typedef enum {
// -------------------------  Cortex-M0 Processor Exceptions Numbers  -----------------------------
  Reset_IRQn                        = -15,  /*!<   1  Reset Vector, invoked on Power up and warm reset */
  NonMaskableInt_IRQn               = -14,  /*!<   2  Non maskable Interrupt, cannot be stopped or preempted */
  HardFault_IRQn                    = -13,  /*!<   3  Hard Fault, all classes of Fault */
  SVCall_IRQn                       =  -5,  /*!<  11  System Service Call via SVC instruction */
  DebugMonitor_IRQn                 =  -4,  /*!<  12  Debug Monitor                    */
  PendSV_IRQn                       =  -2,  /*!<  14  Pendable request for system service */
  SysTick_IRQn                      =  -1,  /*!<  15  System Tick Timer                */
// ----------------------------  nRF51 Specific Interrupt Numbers  --------------------------------
  POWER_CLOCK_IRQn                  =   0,  /*!<   0  POWER_CLOCK                      */
  RADIO_IRQn                        =   1,  /*!<   1  RADIO                            */
  UART0_IRQn                        =   2,  /*!<   2  UART0                            */
  SPIM0_IRQn                        =   3,  /*!<   3  SPIM0                            */
  SPIM1_IRQn                        =   4,  /*!<   4  SPIM1                            */
  WOP_IRQn                          =   5,  /*!<   5  WOP                              */
  GPIOTE_IRQn                       =   6,  /*!<   6  GPIOTE                           */
  ADC_IRQn                          =   7,  /*!<   7  ADC                              */
  TIMER0_IRQn                       =   8,  /*!<   8  TIMER0                           */
  TIMER1_IRQn                       =   9,  /*!<   9  TIMER1                           */
  TIMER2_IRQn                       =  10,  /*!<  10  TIMER2                           */
  RTC0_IRQn                         =  11,  /*!<  11  RTC0                             */
  TEMP_IRQn                         =  12,  /*!<  12  TEMP                             */
  RNG_IRQn                          =  13,  /*!<  13  RNG                              */
  ECB_IRQn                          =  14,  /*!<  14  ECB                              */
  CCM_IRQn                          =  15,  /*!<  15  CCM                              */
  WDOG_IRQn                         =  16,  /*!<  16  WDOG                             */
  RTC1_IRQn                         =  17,  /*!<  17  RTC1                             */
  RDEC_IRQn                         =  18,  /*!<  18  RDEC                             */
  SWI0_IRQn                         =  20,  /*!<  20  SWI0                             */
  SWI1_IRQn                         =  21,  /*!<  21  SWI1                             */
  SWI2_IRQn                         =  22,  /*!<  22  SWI2                             */
  SWI3_IRQn                         =  23,  /*!<  23  SWI3                             */
  SWI4_IRQn                         =  24,  /*!<  24  SWI4                             */
  SWI5_IRQn                         =  25   /*!<  25  SWI5                             */
} IRQn_Type;


/** @addtogroup Configuration_of_CMSIS
  * @{
  */

/* Processor and Core Peripheral Section */ /* Configuration of the Cortex-M0 Processor and Core Peripherals */

#define __CM0_REV              0x0200       /*!< Cortex-M3 Core Revision               */
#define __MPU_PRESENT             0         /*!< MPU present or not                    */
#define __NVIC_PRIO_BITS          2         /*!< Number of Bits used for Priority Levels */
#define __Vendor_SysTickConfig    0         /*!< Set to 1 if different SysTick Config is used */
/** @} */ /* End of group Configuration_of_CMSIS */

#include <core_cm0.h>                       /*!< Cortex-M0 processor and core peripherals */
#include "system_nRF51.h"                   /*!< nRF51 System                          */

/** @addtogroup Device_Peripheral_Registers
  * @{
  */


// ------------------------------------------------------------------------------------------------
// -----                                          MEM                                         -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief Memory Control (MEM)
  */

typedef struct {                            /*!< MEM Structure                         */
  __I  uint32_t  RESERVED0[327];
  __IO uint32_t  GPREGRET;                  /*!< General purpose retention register.   */
  __IO uint32_t  RAMREMAP;                  /*!< RAM remap.                            */
  __I  uint32_t  RESERVED1;
  __IO uint32_t  PERR0;                     /*!< Definition of peripherals in memory region 0. */
  __IO uint32_t  RLENR0;                    /*!< Length of RAM region 0.               */
} NRF_MEM_Type;


// ------------------------------------------------------------------------------------------------
// -----                                         POWER                                        -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief Power Control (POWER)
  */

typedef struct {                            /*!< POWER Structure                       */
  __I  uint32_t  RESERVED0[30];
  __IO uint32_t  TASKS_CONSTLAT;            /*!< Enable constant latency mode.         */
  __IO uint32_t  TASK_LOWPWR;               /*!< Enable low power mode (variable latency). */
  __I  uint32_t  RESERVED1[34];
  __IO uint32_t  EVENTS_POFWARN;            /*!< Power failure warning.                */
  __I  uint32_t  RESERVED2[189];
  __IO uint32_t  RESETREAS;                 /*!< Reset reason.                         */
  __I  uint32_t  PERRDY;                    /*!< Periferal on/off status.              */
  __I  uint32_t  RESERVED3[62];
  __O  uint32_t  SYSTEMOFF;                 /*!< System off register.                  */
  __IO uint32_t  PERPOWER;                  /*!< Peripheral power configuration.       */
  __I  uint32_t  RESERVED4[2];
  __IO uint32_t  POFCON;                    /*!< Power failure configuration.          */
  __I  uint32_t  RESERVED5[4];
  __IO uint32_t  RAMON;                     /*!< Ram on/off.                           */
} NRF_POWER_Type;


// ------------------------------------------------------------------------------------------------
// -----                                         CLOCK                                        -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief Clock control. (CLOCK)
  */

typedef struct {                            /*!< CLOCK Structure                       */
  __IO uint32_t  TASKS_M16START;            /*!< Start 16MHz clock source.             */
  __IO uint32_t  TASKS_M16STOP;             /*!< Stop 16MHz clock source.              */
  __IO uint32_t  TASKS_KI32START;           /*!< Start 32kiHz clock source.            */
  __IO uint32_t  TASKS_KI32STOP;            /*!< Stop 32kiHz clock source.             */
  __I  uint32_t  RESERVED0[60];
  __IO uint32_t  EVENTS_M16STARTED;         /*!< 16MHz oscillator started.             */
  __IO uint32_t  EVENTS_KI32STARTED;        /*!< 32kiHz oscillator started.            */
  __I  uint32_t  RESERVED1[127];
  __IO uint32_t  INTENSET;                  /*!< Interrupt enable set register.        */
  __IO uint32_t  INTENCLR;                  /*!< Interrupt enable clear register.      */
  __I  uint32_t  RESERVED2[131];
  __IO uint32_t  KI32SRC;                   /*!< Clock source for the 32kiHz clock.    */
} NRF_CLOCK_Type;


// ------------------------------------------------------------------------------------------------
// -----                                         RADIO                                        -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief The radio (RADIO)
  */

typedef struct {                            /*!< RADIO Structure                       */
  __IO uint32_t  TASKS_TXEN;                /*!< Enable radio in TX mode.              */
  __IO uint32_t  TASKS_RXEN;                /*!< Enable radio in RX mode.              */
  __IO uint32_t  TASKS_START;               /*!< Start radio.                          */
  __IO uint32_t  TASKS_STOP;                /*!< Stop radio.                           */
  __IO uint32_t  TASKS_DISABLE;             /*!< Disable radio.                        */
  __IO uint32_t  TASKS_RSSISTART;           /*!< Start the RSSI and take one sample of the receive signal strength. */
  __IO uint32_t  TASKS_RSSISTOP;            /*!< Stop the RSSI measurement.            */
  __I  uint32_t  RESERVED0[57];
  __IO uint32_t  EVENTS_READY;              /*!< Ready event.                          */
  __IO uint32_t  EVENTS_ADDRESS;            /*!< Address event.                        */
  __IO uint32_t  EVENTS_PAYLOAD;            /*!< Payload event.                        */
  __IO uint32_t  EVENTS_END;                /*!< End event.                            */
  __IO uint32_t  EVENTS_DISABLED;           /*!< Disable event.                        */
  __I  uint32_t  RESERVED1[2];
  __IO uint32_t  EVENTS_RSSIEND;            /*!< Sampling of the receive signal strength complete. A new RSSI sample is ready for readout at the RSSISAMPLE register. */
  __I  uint32_t  RESERVED2[56];
  __IO uint32_t  SHORTS;                    /*!< Shortcut for the radio.               */
  __I  uint32_t  RESERVED3[63];
  __IO uint32_t  INTEN;                     /*!< Interrupt enable register.            */
  __IO uint32_t  INTENSET;                  /*!< Interrupt enable set register.        */
  __IO uint32_t  INTENCLR;                  /*!< Interrupt enable clear register.      */
  __I  uint32_t  RESERVED4[61];
  __IO uint32_t  CRCSTATUS;                 /*!< CRC status register.                  */
  __I  uint32_t  RESERVED5;
  __IO uint32_t  RXMATCH;                   /*!< Received address.                     */
  __IO uint32_t  RXCRC;                     /*!< Received CRC.                         */
  __I  uint32_t  RESERVED6[61];
  __IO uint32_t  PACKETPTR;                 /*!< Packet pointer. Decision point: START task. */
  __IO uint32_t  FREQUENCY;                 /*!< Frequency.                            */
  __IO uint32_t  TXPOWER;                   /*!< Output power.                         */
  __IO uint32_t  MODE;                      /*!< Data rate and modulation.             */
  __IO uint32_t  PCNF0;                     /*!< Packet configuration 0.               */
  __IO uint32_t  PCNF1;                     /*!< Packet configuration 1.               */
  __IO uint32_t  BASE0;                     /*!< Radio base address 0. Decision point: START task. */
  __IO uint32_t  BASE1;                     /*!< Radio base address 1. Decision point: START task. */
  __IO uint32_t  PREFIX0;                   /*!< Prefixes bytes for logical addresses 0 to 3. */
  __IO uint32_t  PREFIX1;                   /*!< Prefixes bytes for logical addresses 4 to 7. */
  __IO uint32_t  TXADDRESS;                 /*!< Transmit address select.              */
  __IO uint32_t  RXADDRESSES;               /*!< Receive address select.               */
  __IO uint32_t  CRCCNF;                    /*!< CRC configuration.                    */
  __IO uint32_t  CRCPOLY;                   /*!< CRC polynomial.                       */
  __IO uint32_t  CRCINIT;                   /*!< CRC initial value.                    */
  __IO uint32_t  TEST;                      /*!< Test features enable register.        */
  __I  uint32_t  RESERVED7;
  __IO uint32_t  RSSISAMPLE;                /*!< RSSI sample.                          */
  __I  uint32_t  RESERVED8;
  __I  uint32_t  STATE;                     /*!< Current radio state.                  */
  __IO uint32_t  DATAWHITEIV;               /*!< Data whitening initial value.         */
} NRF_RADIO_Type;


// ------------------------------------------------------------------------------------------------
// -----                                         UART0                                        -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief Universal Asynchronous Receiver/Transmitter. (UART0)
  */

typedef struct {                            /*!< UART0 Structure                       */
  __IO uint32_t  TASKS_STARTRX;             /*!< Start UART receiver.                  */
  __IO uint32_t  TASKS_STOPRX;              /*!< Stop UART receiver.                   */
  __IO uint32_t  TASKS_STARTTX;             /*!< Start UART transmitter.               */
  __IO uint32_t  TASKS_STOPTX;              /*!< Stop UART transmitter.                */
  __I  uint32_t  RESERVED0[62];
  __IO uint32_t  EVENTS_RXDRDY;             /*!< Data received in RXD.                 */
  __I  uint32_t  RESERVED1[4];
  __IO uint32_t  EVENTS_TXDRDY;             /*!< Data sent from TXD.                   */
  __I  uint32_t  RESERVED2;
  __IO uint32_t  EVENTS_ERROR;              /*!< Error detected.                       */
  __I  uint32_t  RESERVED3[118];
  __IO uint32_t  INTEN;                     /*!< Interrupt enable register.            */
  __IO uint32_t  INTENSET;                  /*!< Interrupt enable set register.        */
  __IO uint32_t  INTENCLR;                  /*!< Interrupt enable clear register.      */
  __I  uint32_t  RESERVED4[93];
  __IO uint32_t  ERRORSRC;                  /*!< Error source. Write error field to 1 to clear error. */
  __I  uint32_t  RESERVED5[31];
  __IO uint32_t  ENABLE;                    /*!< Enable UART and acquire IOs.          */
  __I  uint32_t  RESERVED6;
  __IO uint32_t  PSELRTS;                   /*!< Pin select for RTS.                   */
  __IO uint32_t  PSELTXD;                   /*!< Pin select for TXD.                   */
  __IO uint32_t  PSELCTS;                   /*!< Pin select for CTS.                   */
  __IO uint32_t  PSELRXD;                   /*!< Pin select for RXD.                   */
  __IO uint32_t  RXD;                       /*!< RXD register.                         */
  __IO uint32_t  TXD;                       /*!< TXD register.                         */
  __I  uint32_t  RESERVED7;
  __IO uint32_t  BAUDRATE;                  /*!< UART Baudrate.                        */
  __I  uint32_t  RESERVED8[17];
  __IO uint32_t  CONFIG;                    /*!< Configuration of parity and hardware flow control register. */
  __IO uint32_t  RXPARITY;                  /*!< RX parity.                            */
  __IO uint32_t  TXPARITY;                  /*!< TX parity.                            */
} NRF_UART0_Type;


// ------------------------------------------------------------------------------------------------
// -----                                         SPIM0                                        -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief SPI master (SPIM0)
  */

typedef struct {                            /*!< SPIM0 Structure                       */
  __I  uint32_t  RESERVED0[66];
  __IO uint32_t  EVENTS_READY;              /*!< TXD byte sent and RXD byte received.  */
  __I  uint32_t  RESERVED1[125];
  __IO uint32_t  INTEN;                     /*!< Interrupt enable register.            */
  __IO uint32_t  INTENSET;                  /*!< Interrupt enable set register.        */
  __IO uint32_t  INTENCLR;                  /*!< Interrupt enable clear register.      */
  __I  uint32_t  RESERVED2[125];
  __IO uint32_t  ENABLE;                    /*!< Enable SPIM.                          */
  __I  uint32_t  RESERVED3;
  __IO uint32_t  PSELSCK;                   /*!< Pin select for SCK.                   */
  __IO uint32_t  PSELMOSI;                  /*!< Pin select for MOSI.                  */
  __IO uint32_t  PSELMISO;                  /*!< Pin select for MISO.                  */
  __I  uint32_t  RESERVED4;
  __IO uint32_t  RXD;                       /*!< RX data.                              */
  __IO uint32_t  TXD;                       /*!< TX data.                              */
  __I  uint32_t  RESERVED5;
  __IO uint32_t  FREQUENCY;                 /*!< SPIM frequency                        */
  __I  uint32_t  RESERVED6[11];
  __IO uint32_t  CONFIG;                    /*!< RX data                               */
} NRF_SPIM0_Type;


// ------------------------------------------------------------------------------------------------
// -----                                         SPIM1                                        -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief SPIM 1 (SPIM1)
  */

typedef struct {                            /*!< SPIM1 Structure                       */
  __I  uint32_t  RESERVED0[66];
  __IO uint32_t  EVENTS_READY;              /*!< TXD byte sent and RXD byte received.  */
  __I  uint32_t  RESERVED1[125];
  __IO uint32_t  INTEN;                     /*!< Interrupt enable register.            */
  __IO uint32_t  INTENSET;                  /*!< Interrupt enable set register.        */
  __IO uint32_t  INTENCLR;                  /*!< Interrupt enable clear register.      */
  __I  uint32_t  RESERVED2[125];
  __IO uint32_t  ENABLE;                    /*!< Enable SPIM.                          */
  __I  uint32_t  RESERVED3;
  __IO uint32_t  PSELSCK;                   /*!< Pin select for SCK.                   */
  __IO uint32_t  PSELMOSI;                  /*!< Pin select for MOSI.                  */
  __IO uint32_t  PSELMISO;                  /*!< Pin select for MISO.                  */
  __I  uint32_t  RESERVED4;
  __IO uint32_t  RXD;                       /*!< RX data.                              */
  __IO uint32_t  TXD;                       /*!< TX data.                              */
  __I  uint32_t  RESERVED5;
  __IO uint32_t  FREQUENCY;                 /*!< SPIM frequency                        */
  __I  uint32_t  RESERVED6[11];
  __IO uint32_t  CONFIG;                    /*!< RX data                               */
} NRF_SPIM1_Type;


// ------------------------------------------------------------------------------------------------
// -----                                        GPIOTE                                        -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief GPIO tasks and events (GPIOTE)
  */

typedef struct {                            /*!< GPIOTE Structure                      */
  __IO uint32_t  TASKS_OUT[4];              /*!< Tasks asssociated with GPIOTE channels. */
  __I  uint32_t  RESERVED0[60];
  __IO uint32_t  EVENTS_IN[4];              /*!< Tasks asssociated with GPIOTE channels. */
  __I  uint32_t  RESERVED1[27];
  __IO uint32_t  EVENTS_PORT;               /*!< Event generated from multiple pins.   */
  __I  uint32_t  RESERVED2[96];
  __IO uint32_t  INTEN;                     /*!< GPIOTE interrupt enable register.     */
  __IO uint32_t  INTENSET;                  /*!< GPIOTE interrupt enable set register. */
  __IO uint32_t  INTENCLR;                  /*!< GPIOTE interrupt enable clear register. */
  __I  uint32_t  RESERVED3[129];
  __IO uint32_t  CONFIG[4];                 /*!< Channel configuration registers.      */
} NRF_GPIOTE_Type;


// ------------------------------------------------------------------------------------------------
// -----                                          ADC                                         -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief Analog to digital converter. (ADC)
  */

typedef struct {                            /*!< ADC Structure                         */
  __O  uint32_t  TASKS_STARTCONV;           /*!< Start an ADC conversion.              */
  __I  uint32_t  RESERVED0[63];
  __IO uint32_t  EVENTS_ENDCONV;            /*!< ADC conversion complete.              */
  __I  uint32_t  RESERVED1[128];
  __IO uint32_t  INTENSET;                  /*!< ADC interrupt enable set register.    */
  __IO uint32_t  INTENCLR;                  /*!< ADC interrupt enable clear register.  */
  __I  uint32_t  RESERVED2[61];
  __IO uint32_t  BUSY;                      /*!< ADC busy register.                    */
  __I  uint32_t  RESERVED3[63];
  __IO uint32_t  ENABLE;                    /*!< ADC enable.                           */
  __IO uint32_t  CONFIG;                    /*!< ADC configuration register.           */
  __IO uint32_t  SAMPLE;                    /*!< Result of ADC conversion.             */
} NRF_ADC_Type;


// ------------------------------------------------------------------------------------------------
// -----                                        TIMER0                                        -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief Timer 0 (TIMER0)
  */

typedef struct {                            /*!< TIMER0 Structure                      */
  __IO uint32_t  TASKS_START;               /*!< Start Timer.                          */
  __IO uint32_t  TASKS_STOP;                /*!< Stop Timer.                           */
  __IO uint32_t  TASKS_COUNT;               /*!< Increment Timer (In counter mode).    */
  __IO uint32_t  TASKS_CLEAR;               /*!< Clear time (clear CC0 in counter mode). */
  __I  uint32_t  RESERVED0[12];
  __IO uint32_t  TASKS_CAPTURE[4];          /*!< Capture Timer value to CC[n] registers. */
  __I  uint32_t  RESERVED1[60];
  __IO uint32_t  EVENTS_COMPARE[4];         /*!< Compare event on CC[n] match.         */
  __I  uint32_t  RESERVED2[44];
  __IO uint32_t  SHORTS;                    /*!< Shortcuts for COMPAREEVENTs.          */
  __I  uint32_t  RESERVED3[63];
  __IO uint32_t  INTEN;                     /*!< Timer interrupt enable register.      */
  __IO uint32_t  INTENSET;                  /*!< Timer interrupt enable set register.  */
  __IO uint32_t  INTENCLR;                  /*!< Timer interrupt enable clear register. */
  __I  uint32_t  RESERVED4[126];
  __IO uint32_t  MODE;                      /*!< Timer Mode selection.                 */
  __IO uint32_t  BITMODE;                   /*!< Sets timer behaviour.                 */
  __I  uint32_t  RESERVED5;
  __IO uint32_t  PRESCALER;                 /*!< 4-bit prescaler to source clock frequency (max value 9). source code frequency is divided by 2^SCALE. */
  __I  uint32_t  RESERVED6[11];
  __IO uint32_t  CC[4];                     /*!< Capture/compare registers.            */
} NRF_TIMER0_Type;


// ------------------------------------------------------------------------------------------------
// -----                                        TIMER1                                        -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief Timer 1 (TIMER1)
  */

typedef struct {                            /*!< TIMER1 Structure                      */
  __IO uint32_t  TASKS_START;               /*!< Start Timer.                          */
  __IO uint32_t  TASKS_STOP;                /*!< Stop Timer.                           */
  __IO uint32_t  TASKS_COUNT;               /*!< Increment Timer (In counter mode).    */
  __IO uint32_t  TASKS_CLEAR;               /*!< Clear time (clear CC0 in counter mode). */
  __I  uint32_t  RESERVED0[12];
  __IO uint32_t  TASKS_CAPTURE[4];          /*!< Capture Timer value to CC[n] registers. */
  __I  uint32_t  RESERVED1[60];
  __IO uint32_t  EVENTS_COMPARE[4];         /*!< Compare event on CC[n] match.         */
  __I  uint32_t  RESERVED2[44];
  __IO uint32_t  SHORTS;                    /*!< Shortcuts for COMPAREEVENTs.          */
  __I  uint32_t  RESERVED3[63];
  __IO uint32_t  INTEN;                     /*!< Timer interrupt enable register.      */
  __IO uint32_t  INTENSET;                  /*!< Timer interrupt enable set register.  */
  __IO uint32_t  INTENCLR;                  /*!< Timer interrupt enable clear register. */
  __I  uint32_t  RESERVED4[126];
  __IO uint32_t  MODE;                      /*!< Timer Mode selection.                 */
  __IO uint32_t  BITMODE;                   /*!< Sets timer behaviour.                 */
  __I  uint32_t  RESERVED5;
  __IO uint32_t  PRESCALER;                 /*!< 4-bit prescaler to source clock frequency (max value 9). source code frequency is divided by 2^SCALE. */
  __I  uint32_t  RESERVED6[11];
  __IO uint32_t  CC[4];                     /*!< Capture/compare registers.            */
} NRF_TIMER1_Type;


// ------------------------------------------------------------------------------------------------
// -----                                        TIMER2                                        -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief Timer 2 (TIMER2)
  */

typedef struct {                            /*!< TIMER2 Structure                      */
  __IO uint32_t  TASKS_START;               /*!< Start Timer.                          */
  __IO uint32_t  TASKS_STOP;                /*!< Stop Timer.                           */
  __IO uint32_t  TASKS_COUNT;               /*!< Increment Timer (In counter mode).    */
  __IO uint32_t  TASKS_CLEAR;               /*!< Clear time (clear CC0 in counter mode). */
  __I  uint32_t  RESERVED0[12];
  __IO uint32_t  TASKS_CAPTURE[4];          /*!< Capture Timer value to CC[n] registers. */
  __I  uint32_t  RESERVED1[60];
  __IO uint32_t  EVENTS_COMPARE[4];         /*!< Compare event on CC[n] match.         */
  __I  uint32_t  RESERVED2[44];
  __IO uint32_t  SHORTS;                    /*!< Shortcuts for COMPAREEVENTs.          */
  __I  uint32_t  RESERVED3[63];
  __IO uint32_t  INTEN;                     /*!< Timer interrupt enable register.      */
  __IO uint32_t  INTENSET;                  /*!< Timer interrupt enable set register.  */
  __IO uint32_t  INTENCLR;                  /*!< Timer interrupt enable clear register. */
  __I  uint32_t  RESERVED4[126];
  __IO uint32_t  MODE;                      /*!< Timer Mode selection.                 */
  __IO uint32_t  BITMODE;                   /*!< Sets timer behaviour.                 */
  __I  uint32_t  RESERVED5;
  __IO uint32_t  PRESCALER;                 /*!< 4-bit prescaler to source clock frequency (max value 9). source code frequency is divided by 2^SCALE. */
  __I  uint32_t  RESERVED6[11];
  __IO uint32_t  CC[4];                     /*!< Capture/compare registers.            */
} NRF_TIMER2_Type;


// ------------------------------------------------------------------------------------------------
// -----                                         RTC0                                         -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief Real time counter 0 (RTC0)
  */

typedef struct {                            /*!< RTC0 Structure                        */
  __IO uint32_t  TASKS_START;               /*!< Start RTC Counter.                    */
  __IO uint32_t  TASKS_STOP;                /*!< Stop RTC Counter.                     */
  __IO uint32_t  TASKS_CLEAR;               /*!< Clear RTC Counter.                    */
  __IO uint32_t  TASKS_TRIGOVRFLW;          /*!< Set COUNTER to 0xFFFFFFF0.            */
  __I  uint32_t  RESERVED0[60];
  __IO uint32_t  EVENTS_TICK;               /*!< Event on COUNTER increment.           */
  __IO uint32_t  EVENTS_OVRFLW;             /*!< Event on COUNTER overflow.            */
  __I  uint32_t  RESERVED1[14];
  __IO uint32_t  EVENTS_COMPARE[4];         /*!< Compare event on CC[n] match.         */
  __I  uint32_t  RESERVED2[108];
  __IO uint32_t  INTEN;                     /*!< Timer interrupt enable register.      */
  __IO uint32_t  INTENSET;                  /*!< Timer interrupt enable set register.  */
  __IO uint32_t  INTENCLR;                  /*!< Timer interrupt enable clear register. */
  __I  uint32_t  RESERVED3[13];
  __IO uint32_t  EVTEN;                     /*!< Configures event enable state for each RTC event. */
  __IO uint32_t  EVTENSET;                  /*!< Enable events. The reading of this register gives the value of EVTEN. */
  __IO uint32_t  EVTENCLR;                  /*!< Disable events. The reading of this register gives the value of EVTEN. */
  __I  uint32_t  RESERVED4[110];
  __IO uint32_t  COUNTER;                   /*!< Current COUNTER value.                */
  __IO uint32_t  PRESCALER;                 /*!< 12-bit prescaler for COUNTER frequency (32768/(PRESCALER+1)). Must be written when RTC is STOPed. */
  __I  uint32_t  RESERVED5[13];
  __IO uint32_t  CC[4];                     /*!< Capture/compare registers.            */
} NRF_RTC0_Type;


// ------------------------------------------------------------------------------------------------
// -----                                         TEMP                                         -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief Temperature Sensor (TEMP)
  */

typedef struct {                            /*!< TEMP Structure                        */
  __IO uint32_t  TASKS_START;               /*!< Start temperature measurement.        */
  __IO uint32_t  TASKS_STOP;                /*!< Stop temperature measurement.         */
  __I  uint32_t  RESERVED0[62];
  __IO uint32_t  EVENTS_DATARDY;            /*!< Temperature measurement complete, data ready event. */
  __I  uint32_t  RESERVED1[127];
  __IO uint32_t  INTEN;                     /*!< TEMP interrupt enable register.       */
  __IO uint32_t  INTENSET;                  /*!< TEMP interrupt enable set register.   */
  __IO uint32_t  INTENCLR;                  /*!< TEMP interrupt enable clear register. */
  __I  uint32_t  RESERVED2[126];
  __I  uint32_t  TEMP;                      /*!< Temperature.                          */
} NRF_TEMP_Type;


// ------------------------------------------------------------------------------------------------
// -----                                          RNG                                         -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief Random Number Generator (RNG)
  */

typedef struct {                            /*!< RNG Structure                         */
  __IO uint32_t  TASKS_START;               /*!< Start the random number generator.    */
  __IO uint32_t  TASKS_STOP;                /*!< Stop the random number generator.     */
  __I  uint32_t  RESERVED0[62];
  __IO uint32_t  EVENTS_VALRDY;             /*!< New random number generated and written to VALUE register. */
  __I  uint32_t  RESERVED1[127];
  __IO uint32_t  INTEN;                     /*!< RNG interrupt enable register         */
  __IO uint32_t  INTENSET;                  /*!< RNG interrupt enable set register     */
  __IO uint32_t  INTENCLR;                  /*!< RNG interrupt enable clear register   */
  __I  uint32_t  RESERVED2[127];
  __IO uint32_t  VALUE;                     /*!< RNG random number.                    */
} NRF_RNG_Type;


// ------------------------------------------------------------------------------------------------
// -----                                          ECB                                         -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief AES ECB Mode Encryption. (ECB)
  */

typedef struct {                            /*!< ECB Structure                         */
  __IO uint32_t  TASKS_STARTECB;            /*!< Start ECB block encrypt. If a crypto operation is running, this will not initiate a new encryption and the ERRORECB event will be triggered. */
  __IO uint32_t  TASKS_STOPECB;             /*!< Stop current ECB encryption. If a crypto operation is running, this will will trigger the ERRORECB event. */
  __I  uint32_t  RESERVED0[62];
  __IO uint32_t  EVENTS_ENDECB;             /*!< ECB block encrypt complete.           */
  __IO uint32_t  EVENTS_ERRORECB;           /*!< ECB block encrypt aborted due to a STOPECB task or a higher priority CCM encryption. */
  __I  uint32_t  RESERVED1[126];
  __IO uint32_t  INTEN;                     /*!< Interrupt enable register.            */
  __IO uint32_t  INTENSET;                  /*!< Interrupt enable set register.        */
  __IO uint32_t  INTENCLR;                  /*!< Interrupt enable clear register.      */
  __I  uint32_t  RESERVED2[126];
  __IO uint32_t  ECBDATAPTR;                /*!< ECB block encrypt memory pointer.     */
} NRF_ECB_Type;


// ------------------------------------------------------------------------------------------------
// -----                                          CCM                                         -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief AES CCM Mode Encryption. (CCM)
  */

typedef struct {                            /*!< CCM Structure                         */
  __IO uint32_t  TASKS_KSGEN;               /*!< Start generation of key-stream. This operation will stop by itself when completed. */
  __IO uint32_t  TASKS_CRYPT;               /*!< Start encrypt/decrypt. This operation will stop by itself when completed. */
  __I  uint32_t  RESERVED0[62];
  __IO uint32_t  EVENTS_ENDKSGEN;           /*!< Keystream generation completed.       */
  __IO uint32_t  EVENTS_ENDCRYPT;           /*!< Encrypt/decrypt completed.            */
  __I  uint32_t  RESERVED1[62];
  __IO uint32_t  SHORTS;                    /*!< Shortcut for the CCM.                 */
  __I  uint32_t  RESERVED2[63];
  __IO uint32_t  INTEN;                     /*!< Interrupt enable register.            */
  __IO uint32_t  INTENSET;                  /*!< Interrupt enable set register.        */
  __IO uint32_t  INTENCLR;                  /*!< Interrupt enable clear register.      */
  __I  uint32_t  RESERVED3[61];
  __I  uint32_t  MICSTATUS;                 /*!< CCM RX MIC check result.              */
  __I  uint32_t  RESERVED4[64];
  __IO uint32_t  MODE;                      /*!< Operation mode.                       */
  __IO uint32_t  CONFPTR;                   /*!< Pointer to data structure holding AES key and NONCE vector. */
  __IO uint32_t  UPPTR;                     /*!< Pointer to unencrypted packet.        */
  __IO uint32_t  EPPTR;                     /*!< Pointer to encrypted packet.          */
  __IO uint32_t  SCRATCHPTR;                /*!< Pointer to data area used for temporary storage. */
} NRF_CCM_Type;


// ------------------------------------------------------------------------------------------------
// -----                                         WDOG                                         -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief Watchdog (WDOG)
  */

typedef struct {                            /*!< WDOG Structure                        */
  __IO uint32_t  TASKS_START;               /*!< Start the watchdog.                   */
  __I  uint32_t  RESERVED0[63];
  __IO uint32_t  EVENTS_TIMEOUT;            /*!< Watchdog timeout.                     */
  __I  uint32_t  RESERVED1[127];
  __IO uint32_t  INTEN;                     /*!< Interrupt enable register.            */
  __IO uint32_t  INTENSET;                  /*!< Interrupt enable set register.        */
  __IO uint32_t  INTENCLR;                  /*!< Interrupt enable clear register.      */
  __I  uint32_t  RESERVED2[62];
  __IO uint32_t  REQSTATUS;                 /*!< Request status.                       */
  __I  uint32_t  RESERVED3[63];
  __IO uint32_t  CRV;                       /*!< Counter reload value in number of 32kiHz clock cycles. */
  __IO uint32_t  RREN;                      /*!< Reload request enable.                */
  __IO uint32_t  CONFIG;                    /*!< Configuration register.               */
  __I  uint32_t  RESERVED4[61];
  __O  uint32_t  RR[8];                     /*!< Reload requests registers.            */
} NRF_WDOG_Type;


// ------------------------------------------------------------------------------------------------
// -----                                         RTC1                                         -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief RTC 1 (RTC1)
  */

typedef struct {                            /*!< RTC1 Structure                        */
  __IO uint32_t  TASKS_START;               /*!< Start RTC Counter.                    */
  __IO uint32_t  TASKS_STOP;                /*!< Stop RTC Counter.                     */
  __IO uint32_t  TASKS_CLEAR;               /*!< Clear RTC Counter.                    */
  __IO uint32_t  TASKS_TRIGOVRFLW;          /*!< Set COUNTER to 0xFFFFFFF0.            */
  __I  uint32_t  RESERVED0[60];
  __IO uint32_t  EVENTS_TICK;               /*!< Event on COUNTER increment.           */
  __IO uint32_t  EVENTS_OVRFLW;             /*!< Event on COUNTER overflow.            */
  __I  uint32_t  RESERVED1[14];
  __IO uint32_t  EVENTS_COMPARE[4];         /*!< Compare event on CC[n] match.         */
  __I  uint32_t  RESERVED2[108];
  __IO uint32_t  INTEN;                     /*!< Timer interrupt enable register.      */
  __IO uint32_t  INTENSET;                  /*!< Timer interrupt enable set register.  */
  __IO uint32_t  INTENCLR;                  /*!< Timer interrupt enable clear register. */
  __I  uint32_t  RESERVED3[13];
  __IO uint32_t  EVTEN;                     /*!< Configures event enable state for each RTC event. */
  __IO uint32_t  EVTENSET;                  /*!< Enable events. The reading of this register gives the value of EVTEN. */
  __IO uint32_t  EVTENCLR;                  /*!< Disable events. The reading of this register gives the value of EVTEN. */
  __I  uint32_t  RESERVED4[110];
  __IO uint32_t  COUNTER;                   /*!< Current COUNTER value.                */
  __IO uint32_t  PRESCALER;                 /*!< 12-bit prescaler for COUNTER frequency (32768/(PRESCALER+1)). Must be written when RTC is STOPed. */
  __I  uint32_t  RESERVED5[13];
  __IO uint32_t  CC[4];                     /*!< Capture/compare registers.            */
} NRF_RTC1_Type;


// ------------------------------------------------------------------------------------------------
// -----                                         RDEC                                         -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief Rotary decoder (RDEC)
  */

typedef struct {                            /*!< RDEC Structure                        */
  __I  uint32_t  RESERVED;                  /*!< Reserved.                             */
} NRF_RDEC_Type;


// ------------------------------------------------------------------------------------------------
// -----                                          SWI                                         -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief SW Interrupts (SWI)
  */

typedef struct {                            /*!< SWI Structure                         */
  __I  uint32_t  RESERVED;                  /*!< Reserved.                             */
} NRF_SWI_Type;


// ------------------------------------------------------------------------------------------------
// -----                                         NVMC                                         -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief Non Volatile Memory Controller (NVMC)
  */

typedef struct {                            /*!< NVMC Structure                        */
  __I  uint32_t  RESERVED0[256];
  __I  uint32_t  READY;                     /*!< Ready flag.                           */
  __I  uint32_t  RESERVED1[64];
  __IO uint32_t  CONFIG;                    /*!< Configuration register.               */
  __IO uint32_t  ERASEPCR1;                 /*!< Register for erasing a page in code region 1. */
  __IO uint32_t  ERASEALL;                  /*!< Register for erasing all non-volatile user memory. */
  __IO uint32_t  ERASEPCR0;                 /*!< Register for erasing a page in code region 0. */
  __IO uint32_t  ERASEUICR;                 /*!< Register for start erasing User Information Congfiguration Registers. */
} NRF_NVMC_Type;


// ------------------------------------------------------------------------------------------------
// -----                                          PPI                                         -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief PPI controller (PPI)
  */

typedef struct {                            /*!< PPI Structure                         */
  __IO uint32_t  TASKS_CHG0EN;              /*!< Enable channel group 0.               */
  __IO uint32_t  TASKS_CHG0DIS;             /*!< Disable channel group 0.              */
  __IO uint32_t  TASKS_CHG1EN;              /*!< Enable channel group 1.               */
  __IO uint32_t  TASKS_CHG1DIS;             /*!< Disable channel group 1.              */
  __IO uint32_t  TASKS_CHG2EN;              /*!< Enable channel group 2.               */
  __IO uint32_t  TASKS_CHG2DIS;             /*!< Disable channel group 2.              */
  __IO uint32_t  TASKS_CHG3EN;              /*!< Enable channel group 3.               */
  __IO uint32_t  TASKS_CHG3DIS;             /*!< Disable channel group 3.              */
  __I  uint32_t  RESERVED0[312];
  __IO uint32_t  CHEN;                      /*!< Channel enable.                       */
  __IO uint32_t  CHENSET;                   /*!< Channel enable set.                   */
  __IO uint32_t  CHENCLR;                   /*!< Channel enable clear.                 */
  __I  uint32_t  RESERVED1;
  __IO uint32_t  CH0_EEP;                   /*!< Channel 0 event end-point.            */
  __IO uint32_t  CH0_TEP;                   /*!< Channel 0 task end-point.             */
  __IO uint32_t  CH1_EEP;                   /*!< Channel 1 event end-point.            */
  __IO uint32_t  CH1_TEP;                   /*!< Channel 1 task end-point.             */
  __IO uint32_t  CH2_EEP;                   /*!< Channel 2 event end-point.            */
  __IO uint32_t  CH2_TEP;                   /*!< Channel 2 task end-point.             */
  __IO uint32_t  CH3_EEP;                   /*!< Channel 3 event end-point.            */
  __IO uint32_t  CH3_TEP;                   /*!< Channel 3 task end-point.             */
  __IO uint32_t  CH4_EEP;                   /*!< Channel 4 event end-point.            */
  __IO uint32_t  CH4_TEP;                   /*!< Channel 4 task end-point.             */
  __IO uint32_t  CH5_EEP;                   /*!< Channel 5 event end-point.            */
  __IO uint32_t  CH5_TEP;                   /*!< Channel 5 task end-point.             */
  __IO uint32_t  CH6_EEP;                   /*!< Channel 6 event end-point.            */
  __IO uint32_t  CH6_TEP;                   /*!< Channel 6 task end-point.             */
  __IO uint32_t  CH7_EEP;                   /*!< Channel 7 event end-point.            */
  __IO uint32_t  CH7_TEP;                   /*!< Channel 7 task end-point.             */
  __IO uint32_t  CH8_EEP;                   /*!< Channel 8 event end-point.            */
  __IO uint32_t  CH8_TEP;                   /*!< Channel 8 task end-point.             */
  __IO uint32_t  CH9_EEP;                   /*!< Channel 9 event end-point.            */
  __IO uint32_t  CH9_TEP;                   /*!< Channel 9 task end-point.             */
  __IO uint32_t  CH10_EEP;                  /*!< Channel 10 event end-point.           */
  __IO uint32_t  CH10_TEP;                  /*!< Channel 10 task end-point.            */
  __IO uint32_t  CH11_EEP;                  /*!< Channel 11 event end-point.           */
  __IO uint32_t  CH11_TEP;                  /*!< Channel 11 task end-point.            */
  __IO uint32_t  CH12_EEP;                  /*!< Channel 12 event end-point.           */
  __IO uint32_t  CH12_TEP;                  /*!< Channel 12 task end-point.            */
  __IO uint32_t  CH13_EEP;                  /*!< Channel 13 event end-point.           */
  __IO uint32_t  CH13_TEP;                  /*!< Channel 13 task end-point.            */
  __IO uint32_t  CH14_EEP;                  /*!< Channel 14 event end-point.           */
  __IO uint32_t  CH14_TEP;                  /*!< Channel 14 task end-point.            */
  __IO uint32_t  CH15_EEP;                  /*!< Channel 15 event end-point.           */
  __IO uint32_t  CH15_TEP;                  /*!< Channel 15 task end-point.            */
  __I  uint32_t  RESERVED2[156];
  __IO uint32_t  CHG0;                      /*!< Channel group 0.                      */
  __IO uint32_t  CHG1;                      /*!< Channel group 1.                      */
  __IO uint32_t  CHG2;                      /*!< Channel group 2.                      */
  __IO uint32_t  CHG3;                      /*!< Channel group 3.                      */
} NRF_PPI_Type;


// ------------------------------------------------------------------------------------------------
// -----                                         FICR                                         -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief Factory Information Configuration (FICR)
  */

typedef struct {                            /*!< FICR Structure                        */
  __I  uint32_t  RESERVED0[4];
  __I  uint32_t  CODEPAGESIZE;              /*!< Code memory page size in bytes.       */
  __I  uint32_t  CODESIZE;                  /*!< Code memory size in pages.            */
  __IO uint32_t  CODEBASE;                  /*!< Start address of code memory.         */
  __I  uint32_t  RESERVED1[3];
  __I  uint32_t  CLENR0;                    /*!< Length of code region 0 in bytes.     */
  __I  uint32_t  PPFC;                      /*!< Pre-programmed factory code present.  */
} NRF_FICR_Type;


// ------------------------------------------------------------------------------------------------
// -----                                         UICR                                         -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief User Information Configuration (UICR)
  */

typedef struct {                            /*!< UICR Structure                        */
  __IO uint32_t  CLENR0;                    /*!< Length of code region 0.              */
  __IO uint32_t  RBPCONF;                   /*!< Readback protection configuration.    */
  __IO uint32_t  XTALFREQ;                  /*!< Nominal frequency of high frequency xtal used in the design. */
} NRF_UICR_Type;


// ------------------------------------------------------------------------------------------------
// -----                                         GPIO                                         -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief General purpose input and output (GPIO)
  */

typedef struct {                            /*!< GPIO Structure                        */
  __I  uint32_t  RESERVED0[321];
  __IO uint32_t  OUT;                       /*!< Write GPIO port.                      */
  __IO uint32_t  OUTSET;                    /*!< Set individual bits in GPIO port.     */
  __IO uint32_t  OUTCLR;                    /*!< Clear individual bits in GPIO port.   */
  __IO uint32_t  IN;                        /*!< Read GPIO port.                       */
  __IO uint32_t  DIR;                       /*!< Direction of GPIO pins.               */
  __IO uint32_t  DIRSET;                    /*!< Setting DIR register.                 */
  __IO uint32_t  DIRCLR;                    /*!< Clearing DIR register.                */
  __I  uint32_t  RESERVED1[56];
  __IO uint32_t  PIN0_OUT;                  /*!< GPIO pin 0 write register.            */
  __IO uint32_t  PIN0_IN;                   /*!< GPIO pin 0 read register.             */
  __IO uint32_t  PIN1_OUT;                  /*!< GPIO pin 1 write register.            */
  __IO uint32_t  PIN1_IN;                   /*!< GPIO pin 1 read register.             */
  __IO uint32_t  PIN2_OUT;                  /*!< GPIO pin 2 write register.            */
  __IO uint32_t  PIN2_IN;                   /*!< GPIO pin 2 read register.             */
  __IO uint32_t  PIN3_OUT;                  /*!< GPIO pin 3 write register.            */
  __IO uint32_t  PIN3_IN;                   /*!< GPIO pin 3 read register.             */
  __IO uint32_t  PIN4_OUT;                  /*!< GPIO pin 4 write register.            */
  __IO uint32_t  PIN4_IN;                   /*!< GPIO pin 4 read register.             */
  __IO uint32_t  PIN5_OUT;                  /*!< GPIO pin 5 write register.            */
  __IO uint32_t  PIN5_IN;                   /*!< GPIO pin 5 read register.             */
  __IO uint32_t  PIN6_OUT;                  /*!< GPIO pin 6 write register.            */
  __IO uint32_t  PIN6_IN;                   /*!< GPIO pin 6 read register.             */
  __IO uint32_t  PIN7_OUT;                  /*!< GPIO pin 7 write register.            */
  __IO uint32_t  PIN7_IN;                   /*!< GPIO pin 7 read register.             */
  __IO uint32_t  PIN8_OUT;                  /*!< GPIO pin 8 write register.            */
  __IO uint32_t  PIN8_IN;                   /*!< GPIO pin 8 read register.             */
  __IO uint32_t  PIN9_OUT;                  /*!< GPIO pin 9 write register.            */
  __IO uint32_t  PIN9_IN;                   /*!< GPIO pin 9 read register.             */
  __IO uint32_t  PIN10_OUT;                 /*!< GPIO pin 10 write register.           */
  __IO uint32_t  PIN10_IN;                  /*!< GPIO pin 10 read register.            */
  __IO uint32_t  PIN11_OUT;                 /*!< GPIO pin 11 write register.           */
  __IO uint32_t  PIN11_IN;                  /*!< GPIO pin 11 read register.            */
  __IO uint32_t  PIN12_OUT;                 /*!< GPIO pin 12 write register.           */
  __IO uint32_t  PIN12_IN;                  /*!< GPIO pin 12 read register.            */
  __IO uint32_t  PIN13_OUT;                 /*!< GPIO pin 13 write register.           */
  __IO uint32_t  PIN13_IN;                  /*!< GPIO pin 13 read register.            */
  __IO uint32_t  PIN14_OUT;                 /*!< GPIO pin 14 write register.           */
  __IO uint32_t  PIN14_IN;                  /*!< GPIO pin 14 read register.            */
  __IO uint32_t  PIN15_OUT;                 /*!< GPIO pin 15 write register.           */
  __IO uint32_t  PIN15_IN;                  /*!< GPIO pin 15 read register.            */
  __IO uint32_t  PIN16_OUT;                 /*!< GPIO pin 16 write register.           */
  __IO uint32_t  PIN16_IN;                  /*!< GPIO pin 16 read register.            */
  __IO uint32_t  PIN17_OUT;                 /*!< GPIO pin 17 write register.           */
  __IO uint32_t  PIN17_IN;                  /*!< GPIO pin 17 read register.            */
  __IO uint32_t  PIN18_OUT;                 /*!< GPIO pin 18 write register.           */
  __IO uint32_t  PIN18_IN;                  /*!< GPIO pin 18 read register.            */
  __IO uint32_t  PIN19_OUT;                 /*!< GPIO pin 19 write register.           */
  __IO uint32_t  PIN19_IN;                  /*!< GPIO pin 19 read register.            */
  __IO uint32_t  PIN20_OUT;                 /*!< GPIO pin 20 write register.           */
  __IO uint32_t  PIN20_IN;                  /*!< GPIO pin 20 read register.            */
  __IO uint32_t  PIN21_OUT;                 /*!< GPIO pin 21 write register.           */
  __IO uint32_t  PIN21_IN;                  /*!< GPIO pin 21 read register.            */
  __IO uint32_t  PIN22_OUT;                 /*!< GPIO pin 22 write register.           */
  __IO uint32_t  PIN22_IN;                  /*!< GPIO pin 22 read register.            */
  __IO uint32_t  PIN23_OUT;                 /*!< GPIO pin 23 write register.           */
  __IO uint32_t  PIN23_IN;                  /*!< GPIO pin 23 read register.            */
  __IO uint32_t  PIN24_OUT;                 /*!< GPIO pin 24 write register.           */
  __IO uint32_t  PIN24_IN;                  /*!< GPIO pin 24 read register.            */
  __IO uint32_t  PIN25_OUT;                 /*!< GPIO pin 25 write register.           */
  __IO uint32_t  PIN25_IN;                  /*!< GPIO pin 25 read register.            */
  __IO uint32_t  PIN26_OUT;                 /*!< GPIO pin 26 write register.           */
  __IO uint32_t  PIN26_IN;                  /*!< GPIO pin 26 read register.            */
  __IO uint32_t  PIN27_OUT;                 /*!< GPIO pin 27 write register.           */
  __IO uint32_t  PIN27_IN;                  /*!< GPIO pin 27 read register.            */
  __IO uint32_t  PIN28_OUT;                 /*!< GPIO pin 28 write register.           */
  __IO uint32_t  PIN28_IN;                  /*!< GPIO pin 28 read register.            */
  __IO uint32_t  PIN29_OUT;                 /*!< GPIO pin 29 write register.           */
  __IO uint32_t  PIN29_IN;                  /*!< GPIO pin 29 read register.            */
  __IO uint32_t  PIN30_OUT;                 /*!< GPIO pin 30 write register.           */
  __IO uint32_t  PIN30_IN;                  /*!< GPIO pin 30 read register.            */
  __IO uint32_t  PIN31_OUT;                 /*!< GPIO pin 31 write register.           */
  __IO uint32_t  PIN31_IN;                  /*!< GPIO pin 31 read register.            */
  __IO uint32_t  PIN0_CNF;                  /*!< Configuration of pin 0.               */
  __IO uint32_t  PIN1_CNF;                  /*!< Configuration of pin 1.               */
  __IO uint32_t  PIN2_CNF;                  /*!< Configuration of pin 2.               */
  __IO uint32_t  PIN3_CNF;                  /*!< Configuration of pin 3.               */
  __IO uint32_t  PIN4_CNF;                  /*!< Configuration of pin 4.               */
  __IO uint32_t  PIN5_CNF;                  /*!< Configuration of pin 5.               */
  __IO uint32_t  PIN6_CNF;                  /*!< Configuration of pin 6.               */
  __IO uint32_t  PIN7_CNF;                  /*!< Configuration of pin 7.               */
  __IO uint32_t  PIN8_CNF;                  /*!< Configuration of pin 8.               */
  __IO uint32_t  PIN9_CNF;                  /*!< Configuration of pin 9.               */
  __IO uint32_t  PIN10_CNF;                 /*!< Configuration of pin 10.              */
  __IO uint32_t  PIN11_CNF;                 /*!< Configuration of pin 11.              */
  __IO uint32_t  PIN12_CNF;                 /*!< Configuration of pin 12.              */
  __IO uint32_t  PIN13_CNF;                 /*!< Configuration of pin 13.              */
  __IO uint32_t  PIN14_CNF;                 /*!< Configuration of pin 14.              */
  __IO uint32_t  PIN15_CNF;                 /*!< Configuration of pin 15.              */
  __IO uint32_t  PIN16_CNF;                 /*!< Configuration of pin 16.              */
  __IO uint32_t  PIN17_CNF;                 /*!< Configuration of pin 17.              */
  __IO uint32_t  PIN18_CNF;                 /*!< Configuration of pin 18.              */
  __IO uint32_t  PIN19_CNF;                 /*!< Configuration of pin 19.              */
  __IO uint32_t  PIN20_CNF;                 /*!< Configuration of pin 20.              */
  __IO uint32_t  PIN21_CNF;                 /*!< Configuration of pin 21.              */
  __IO uint32_t  PIN22_CNF;                 /*!< Configuration of pin 22.              */
  __IO uint32_t  PIN23_CNF;                 /*!< Configuration of pin 23.              */
  __IO uint32_t  PIN24_CNF;                 /*!< Configuration of pin 24.              */
  __IO uint32_t  PIN25_CNF;                 /*!< Configuration of pin 25.              */
  __IO uint32_t  PIN26_CNF;                 /*!< Configuration of pin 26.              */
  __IO uint32_t  PIN27_CNF;                 /*!< Configuration of pin 27.              */
  __IO uint32_t  PIN28_CNF;                 /*!< Configuration of pin 28.              */
  __IO uint32_t  PIN29_CNF;                 /*!< Configuration of pin 29.              */
  __IO uint32_t  PIN30_CNF;                 /*!< Configuration of pin 30.              */
  __IO uint32_t  PIN31_CNF;                 /*!< Configuration of pin 31.              */
} NRF_GPIO_Type;


// ------------------------------------------------------------------------------------------------
// -----                                          WOP                                         -----
// ------------------------------------------------------------------------------------------------


/**
  * @brief Wake up on pin missing module. (WOP)
  */

typedef struct {                            /*!< WOP Structure                         */
  __I  uint32_t  RESERVED0[64];
  __IO uint32_t  EVENTS_PORT;               /*!< A device address match occurred on the last received packet. */
  __I  uint32_t  RESERVED1[127];
  __IO uint32_t  INTEN;                     /*!< Interrupt enable register.            */
  __IO uint32_t  INTENSET;                  /*!< Interrupt enable set register.        */
  __IO uint32_t  INTENCLR;                  /*!< Interrupt enable clear register.      */
  __I  uint32_t  RESERVED2[13];
  __IO uint32_t  EVTEN;                     /*!< Event enable register.                */
  __IO uint32_t  EVTENSET;                  /*!< Event enable set register.            */
  __IO uint32_t  EVTENCLR;                  /*!< Event enable clear register.          */
} NRF_WOP_Type;



/********************************************
** End of section using anonymous unions   **
*********************************************/

#if defined(__ARMCC_VERSION)
  #pragma pop
#elif defined(__CWCC__)
  #pragma pop
#elif defined(__GNUC__)
  /* leave anonymous unions enabled */
#elif defined(__IAR_SYSTEMS_ICC__)
  #pragma pop
#else
  #error Not supported compiler type
#endif



// ------------------------------------------------------------------------------------------------
// -----                                 Peripheral memory map                                -----
// ------------------------------------------------------------------------------------------------

#define NRF_MEM_BASE              0x40000000
#define NRF_POWER_BASE            0x40000000
#define NRF_CLOCK_BASE            0x40000000
#define NRF_RADIO_BASE            0x40001000
#define NRF_UART0_BASE            0x40002000
#define NRF_SPIM0_BASE            0x40003000
#define NRF_SPIM1_BASE            0x40004000
#define NRF_GPIOTE_BASE           0x40006000
#define NRF_ADC_BASE              0x40007000
#define NRF_TIMER0_BASE           0x40008000
#define NRF_TIMER1_BASE           0x40009000
#define NRF_TIMER2_BASE           0x4000A000
#define NRF_RTC0_BASE             0x4000B000
#define NRF_TEMP_BASE             0x4000C000
#define NRF_RNG_BASE              0x4000D000
#define NRF_ECB_BASE              0x4000E000
#define NRF_CCM_BASE              0x4000F000
#define NRF_WDOG_BASE             0x40010000
#define NRF_RTC1_BASE             0x40011000
#define NRF_RDEC_BASE             0x40012000
#define NRF_SWI_BASE              0x40014000
#define NRF_NVMC_BASE             0x4001E000
#define NRF_PPI_BASE              0x4001F000
#define NRF_FICR_BASE             0x10000000
#define NRF_UICR_BASE             0x10001000
#define NRF_GPIO_BASE             0x50000000
#define NRF_WOP_BASE              0x40005000


// ------------------------------------------------------------------------------------------------
// -----                                Peripheral declaration                                -----
// ------------------------------------------------------------------------------------------------

#define NRF_MEM                   ((NRF_MEM_Type            *) NRF_MEM_BASE)
#define NRF_POWER                 ((NRF_POWER_Type          *) NRF_POWER_BASE)
#define NRF_CLOCK                 ((NRF_CLOCK_Type          *) NRF_CLOCK_BASE)
#define NRF_RADIO                 ((NRF_RADIO_Type          *) NRF_RADIO_BASE)
#define NRF_UART0                 ((NRF_UART0_Type          *) NRF_UART0_BASE)
#define NRF_SPIM0                 ((NRF_SPIM0_Type          *) NRF_SPIM0_BASE)
#define NRF_SPIM1                 ((NRF_SPIM1_Type          *) NRF_SPIM1_BASE)
#define NRF_GPIOTE                ((NRF_GPIOTE_Type         *) NRF_GPIOTE_BASE)
#define NRF_ADC                   ((NRF_ADC_Type            *) NRF_ADC_BASE)
#define NRF_TIMER0                ((NRF_TIMER0_Type         *) NRF_TIMER0_BASE)
#define NRF_TIMER1                ((NRF_TIMER1_Type         *) NRF_TIMER1_BASE)
#define NRF_TIMER2                ((NRF_TIMER2_Type         *) NRF_TIMER2_BASE)
#define NRF_RTC0                  ((NRF_RTC0_Type           *) NRF_RTC0_BASE)
#define NRF_TEMP                  ((NRF_TEMP_Type           *) NRF_TEMP_BASE)
#define NRF_RNG                   ((NRF_RNG_Type            *) NRF_RNG_BASE)
#define NRF_ECB                   ((NRF_ECB_Type            *) NRF_ECB_BASE)
#define NRF_CCM                   ((NRF_CCM_Type            *) NRF_CCM_BASE)
#define NRF_WDOG                  ((NRF_WDOG_Type           *) NRF_WDOG_BASE)
#define NRF_RTC1                  ((NRF_RTC1_Type           *) NRF_RTC1_BASE)
#define NRF_RDEC                  ((NRF_RDEC_Type           *) NRF_RDEC_BASE)
#define NRF_SWI                   ((NRF_SWI_Type            *) NRF_SWI_BASE)
#define NRF_NVMC                  ((NRF_NVMC_Type           *) NRF_NVMC_BASE)
#define NRF_PPI                   ((NRF_PPI_Type            *) NRF_PPI_BASE)
#define NRF_FICR                  ((NRF_FICR_Type           *) NRF_FICR_BASE)
#define NRF_UICR                  ((NRF_UICR_Type           *) NRF_UICR_BASE)
#define NRF_GPIO                  ((NRF_GPIO_Type           *) NRF_GPIO_BASE)
#define NRF_WOP                   ((NRF_WOP_Type            *) NRF_WOP_BASE)



/** @} */ /* End of group Device_Peripheral_Registers */
/** @} */ /* End of group nRF51 */
/** @} */ /* End of group ARM */

#ifdef __cplusplus
}
#endif 


#endif  // __nRF51_H__

