#ifndef _DELAY_H
#define _DELAY_H

#include "nrf.h"
#include "compiler_abstraction.h"

//void delay_us(uint_fast16_t number_of_us);
//void delay_ms(uint_fast16_t number_of_ms);

/*lint --e{438, 522} "Variable not used" "Function lacks side-effects" */
static void __INLINE inline_delay_us(uint_fast16_t volatile number_of_us)
{
  while(number_of_us != 0)
  {
    number_of_us--;
    __NOP();
    __NOP();
    __NOP();
    __NOP();
  }
}

/*lint --e{438} "Variable not used" */
static void __INLINE inline_delay_ms(uint_fast16_t volatile number_of_ms)
{
  while(number_of_ms != 0)
  {
    number_of_ms--;
    inline_delay_us(1000);
  }
}

static void __INLINE nrf_delay_us(uint_fast16_t volatile number_of_us)
{
  inline_delay_us(number_of_us);
}

static void __INLINE nrf_delay_ms(uint_fast16_t volatile number_of_ms)
{
  inline_delay_ms(number_of_ms);
}


#endif
