
#ifndef ADC_H
#define ADC_H

#define SAMPLE_DURATION (1550UL)		/* In ticks. 1550UL->~14kHz */
#define	NORMALIZE		6			/* Input sample<<=NORMALIZE. */

#include <stdint.h>
#include <stdbool.h>
#include <string.h>
#include "nrf.h"
#include "Q16.h"
#include "maths.h"
#include "uart.h"
#include "config.h"

/* TIMER2 defines. */
#define TIMER2_PRESCALER 0
#define __XTAL (16000000UL)
#define TIMER2_CLOCK (__XTAL >> TIMER2_PRESCALER)
#define US_TO_TIMER2_TICKS(us) ((1000UL * us) / (TIMER2_CLOCK))

void adc_init(void);
void real_adc_config(void);
void adc_fetch_next_sample(Q16 *block);
bool adc_next_sample_is_ready(void);
void TIMER2_init(void);
void TIMER2_reset(void);
void TIMER2_start(uint32_t sample_rate_ticks);

#endif
