
/* 	System config.
	2012 Even Brenden 
*/

#define N 		64				/* # samples per packet. */
#define DBITS	4				/* # bits for quantization of residue. May cause trouble if >15. */
#define RXTX_BUFFER_SIZE 8192	/* TX and RX buffer sizes. */
#define DACN	4096			/* DAC FIFO cue size as an attempt to sync ADC and DAC on separate devices. */

/* System operation. */
#define IS_TX					/* Is this build a TX only? */
//#define IS_RX					/* Is this build a RX only? */
//#define NO_RF					/* No RF. */
//#define USE_GZLL				/* Use Gazell. Disables IS_TX and IS_RX and NO_RF must not be defined. */
//#define IS_DEVICE				/* Gazell: is this build a defined as device? */
//#define IS_HOST				/* Gazell: is this build a defined as host? */
//#define UART_AS_ADC			/* Disable timer and use UART as ADC. */
//#define UART_AS_DAC			/* Use UART instead of PWM for DAC. */
//#define PURE_PWM

/* ADPCM */
#define ADPCM								/* Use ADPCM, i.e. AQB. Else regular DPCM with midtread Q is used. Either A_AQB or SSM_AQB (never both) must by defined. */
//#define A_AQB								/* Use advanced AQB. */
#define SSM_AQB								/* Use SSM-AQB instead of advanced AQB. */
#define AQB_CONST_Q16 	0x2001				/* A_AQB: See matlab/aqb_calc_const.m. */
#define ALPHA 			Q16_0P9				/* A_AQB: Memory factor. */
#define DELTA_MIN		0x1					/* AQB: Lower bound on delta. */
#define DELTA_MAX		(1<<(16-DBITS+1))	/* AQB: Upper bound on delta. Also initial delta value. */
#define P 				1					/* D: # of LPCs. For nonadaptive, remember to set all lpc[P]s statically. */
#define LPC0 			Q16_0P9				/* D: If nonadaptive, use this as static P. */

/* Profiling with GPIO. */
#define PROFILE				/* Profile main system blocks. */
//#define PROF_ADDA		/* Profile ADC and DAC. */
#ifdef PROFILE
	#define ENCODE_PIN 	(1<<8)
	#define Q_PIN		(1<<9)
	#define PACK_PIN	(1<<10)
	#define TX_PIN		(1<<11)
	#define RX_PIN		(1<<12)
	#define UNPACK_PIN	(1<<13)
	#define DECODE_PIN 	(1<<15)
	#define DQ_PIN		(1<<14)
#endif
#ifdef PROF_ADDA
	#define DAC_CC0_PIN	(1<<8)
	#define DAC_CC1_PIN (1<<9)
	#define DAC_CC2_PIN	(1<<10)
	#define DAC_BLK_PIN (1<<11)
	#define ADC_SMP_PIN (1<<12)
	#define DAC_SNC_PIN	(1<<13)
#endif

/* Debugging. */
#define DEBUG32 uart_put32(0xFFFFFFFFUL);
#define DEBUG	uart_put(0xFF);

/* Macros for optimization. */
#define SHIFT (16-DBITS+1)	/* Shift for Q. */
#define NP 	((N*DBITS)/8)	/* # bytes per packet. */
