
#ifndef DAC_H
#define DAC_H

#include <stdbool.h>
#include <stdint.h>
#include "nrf.h"
#include "nrf_assert.h"
#include "Q16.h"
#include "uart.h"
#include "maths.h"
#include "config.h"
#include "adc.h"

#define PWM_PIN 		(18UL) 		/* Not sufficient to just change this, need to look at gpiote_init() as well. */
#define CARRIER_DUR 	(490UL) 	/* Sample duration and therefore also maximum sample size. */
#define UPSAMPLE_FACTOR 4 			/* Always floor(SAMPLE_DURATION/CARRIER_DUR)). */
#define PWM_BITS 		8			/* Maximum log_2(CARRIER_DUR). */

#define Q16_TO_PWM(q16) (((q16+Q16_1)>>(16-PWM_BITS+1))+1)

/* TIMER1 defines. */
#define TIMER1_PRESCALER 0

void dac_init(void);
void sample_to_dac(Q16 *samples);
Q16 next_pwm_sample(void);
static void gpiote_init(void);
static void ppi_init(void);
void pwm_init(void);

#endif
