
#ifndef GAZELL_H
#define GAZELL_H

#include <stdint.h>
#include <stdbool.h>
#include <string.h>
#include "nrf.h"
#include "nrf_gzll.h"
#include "nrf_gzll_constants.h"
#include "my_gzll_params.h"
#include "uart.h"
#include "Q16.h"
#include "maths.h"
#include "config.h"

#ifdef USE_GZLL

	void gazell_init(void);
	void pack_side_info(uint32_t sbits, Q16* lpc);
	void pack_sample(Q16 sample);
	void transmit(void);
	void buffer_up_rx_packet(void);
	bool RX_next_packet_is_ready(void);
	void fetch_new_samples(Q16 *samples, Q16 *lpc, uint32_t *sbits);
	void unpack_packet(uint8_t *packet, Q16 *samples, Q16 *lpc, uint32_t *sbits);

#endif

#endif
