
/*
	Custom math operations such as calculation of one-sided autocorrelation function.
	2011 Even Brenden
*/

#ifndef MATHS
#define MATHS

#include <stdbool.h>
#include <stdint.h>
#include "nrf.h"
#include "Q16.h"
#include "config.h"

#define MOD(a, b) (a-(b*(a/b)))
#define SET_BIT_MOD_BYTE(bit, index) (bit<<(7-MOD(index, 8)))
#define BIT_IS_SET_MOD_BYTE(number, index) ((number&(1<<7-MOD(index, 8)))>0UL)
#define BIT_IS_SET(number, index) ((number&(1<<index))>0UL)

uint32_t log_2_Q16(Q16 a);

Q16 average_Q16(Q16 *x, uint32_t count);

int32_t modulo(int32_t n, int32_t m);

void acf_Q16(Q16 *x, Q16 *rxx);

void find_max_Q16(Q16 *x, Q16 *result);

void calc_sbits_Q16(Q16 *max, uint32_t *sbits);

Q16 get_scale_Q16(Q16 *x, uint16_t count);

int32_t minimum(int32_t v1, int32_t v2);

int32_t maximum(int32_t v1, int32_t v2);

Q16 neg_Q16(Q16 a);

Q16 absolute_Q16(Q16 v1);

#endif
