
/*
	ADPCM encoder and decoder, not including LPC calculation.
	2011 Even brenden
*/

#ifndef ADPCM_H
#define ADPCM_H

#include <stdint.h>
#include "midrise.h"
#include "caqb.h"
#include "maths.h"
#include "Q16.h"
#include "config.h"

void adpcm_encode_Q16(Q16 *x, Q16 *a, Q16 *x_hat, Q16 *x_tilde, int8_t *xt_pointer, Q16 *prev_delta, Q16 *prev_e, int32_t *codeword);
void adpcm_decode_Q16(Q16 *codeword, Q16 *a, Q16 *s_hat, Q16 *s_tilde, int8_t *st_pointer, Q16 *prev_delta, Q16 *prev_e, Q16 *y);

void dpcm_encode(float *x, uint8_t p, float *a, int8_t dbits, float scale, float *x_hat, float *x_tilde, int8_t *xt_pointer, float *d);
void dpcm_decode(float *x, uint8_t p, float *a, float *s_hat, float *s_tilde, int8_t *st_pointer, float *d);

void dpcm_encode_Q16(Q16 *x, uint8_t p, Q16 *a, Q16 dbits, Q16 *x_hat, Q16 *x_tilde, int8_t *xt_pointer, int32_t *d);
void dpcm_decode_Q16(Q16 *x, uint8_t p, Q16 *a, Q16 *s_hat, Q16 *s_tilde, int8_t *st_pointer, Q16 *d);

#endif


