
/*
	Custom math operations such as calculation of one-sided autocorrelation function.
	2011 Even Brenden
*/

#ifndef MATHS
#define MATHS
#include <stdint.h>
#include "Q16.h"

#define MOD(a, b) (a-(b*(a/b)))

void debug(int no);

uint8_t log_2_Q16(Q16 a);

float log_2(float a);

Q16 average_Q16(Q16 *x, uint32_t count);

float average(float *x, uint32_t count);

int32_t modulo(int32_t n, int32_t m);

void acf_Q16(Q16 *x, uint16_t count, uint8_t lag, Q16 *rxx);

void acf(float *x, uint16_t count, uint8_t lag, float *rxx);

float get_scale(float *x, uint16_t count);

Q16 get_scale_Q16(Q16 *x, uint16_t count);

int32_t minimum(int32_t v1, int32_t v2);

int32_t maximum(int32_t v1, int32_t v2);

float absolute(float v1);

#endif
